diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index 5729e835e..41db209ef 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -1,30 +1,31 @@
 package net.minecraft.core.block;
 
-import java.util.Objects;
-import java.util.Random;
-import java.util.function.Supplier;
-
-import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
+
+import java.util.function.Supplier;
 
 public class BlockLogicDoor
     extends BlockLogic
@@ -51,14 +52,14 @@ public class BlockLogicDoor
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final int meta = world.getBlockData(tilePos);
         if (world.hasNeighborSignal(tilePos)) {
             world.setBlockDataNotify(tilePos, meta | MASK_OPENED);
             if (this.isTop) {
-                world.setBlockDataNotify(tilePos.down(), meta | MASK_OPENED);
+                world.setBlockDataNotify(tilePos.down(new TilePos()), meta | MASK_OPENED);
             } else {
-                world.setBlockDataNotify(tilePos.up(), meta | MASK_OPENED);
+                world.setBlockDataNotify(tilePos.up(new TilePos()), meta | MASK_OPENED);
             }
             world.playBlockEvent(tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
         }
@@ -75,7 +76,7 @@ public class BlockLogicDoor
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side.isVertical()) return PartialSupport.INSTANCE;
 
         final int data = world.getBlockData(tilePos);
@@ -90,11 +91,11 @@ public class BlockLogicDoor
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.getBoundsForRotation(this.getRotation(source.getBlockData(tilePos)), false);
     }
 
-    public @NotNull AABB getBoundsForRotation(final int rotation, final boolean drawingSelection) {
+    public @NotNull AABBdc getBoundsForRotation(final int rotation, final boolean drawingSelection) {
         final float top, bottom;
         if (this.isTop && drawingSelection) {
             top = 1.0f;
@@ -109,71 +110,73 @@ public class BlockLogicDoor
         final float f = 0.1875F;
         return switch (rotation) {
             case 0 -> // North
-                AABB.fromPool(0.0F, bottom, 0.0F, 1.0F, top, f);
+                new AABBd(0.0F, bottom, 0.0F, 1.0F, top, f);
             case 1 -> // East
-                AABB.fromPool(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
+                new AABBd(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
             case 2 -> // South
-                AABB.fromPool(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
+                new AABBd(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
             case 3 -> // West
-                AABB.fromPool(0.0F, bottom, 0.0F, f, top, 1.0F);
-            default -> AABB.fromPool(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
+                new AABBd(0.0F, bottom, 0.0F, f, top, 1.0F);
+            default -> new AABBd(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
         };
     }
 
     @Override
-    public void onAttacked(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onAttacked(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
         if (!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
             this.onInteracted(world, tilePos, player, side, xHit, yHit);
         }
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @Nullable Player player, final @Nullable Side side, final double xHit, final double yHit) {
-        if (this.material == Material.metal || this.material == Material.steel) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @Nullable Player player, final @Nullable Side side, final double xHit, final double yHit) {
+        if (this.material == Materials.METAL || this.material == Materials.STEEL) {
             return false;
         }
+        TilePos queryPos = new TilePos();
         final int data = world.getBlockData(tilePos);
         if (this.isTop) {
-            final Block<?> b = world.getBlock(tilePos.down());
-            if (b != null && b.getLogic() instanceof BlockLogicDoor) {
-                b.onInteracted(world, tilePos.down(), player, side, xHit, yHit);
+            final Block<?> b = world.getBlock(tilePos.down(queryPos));
+            if (b != null && b.getLogic() instanceof BlockLogicDoor blockLogicDoor) {
+                blockLogicDoor.onInteracted(world, tilePos.down(queryPos), player, side, xHit, yHit);
             }
             return true;
         }
-        final @Nullable Block<?> b = world.getBlock(tilePos.up());
+        final @Nullable Block<?> b = world.getBlock(tilePos.up(queryPos));
         if (b != null && b.getLogic() instanceof BlockLogicDoor) {
-            world.setBlockDataNotify(tilePos.up(), data ^ MASK_OPENED);
+            world.setBlockDataNotify(tilePos.up(queryPos), data ^ MASK_OPENED);
         }
         final int openedData = data ^ MASK_OPENED;
         world.setBlockDataNotify(tilePos, openedData);
         if (!this.isSupported(world, tilePos, openedData)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, openedData, null, null);
             world.setBlockIdNotify(tilePos, 0);
-            if (world.getBlockLogic(tilePos.up(), BlockLogicDoor.class) != null) {
-                world.setBlockIdNotify(tilePos.up(), 0);
+            if (world.getBlockLogic(tilePos.up(queryPos), BlockLogicDoor.class) != null) {
+                world.setBlockIdNotify(tilePos.up(queryPos), 0);
             }
         }
-        world.markBlocksDirty(tilePos.down(), tilePos);
+        world.markBlocksDirty(tilePos.down(queryPos), tilePos);
         world.playBlockEvent(player, tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
         return true;
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         this.onInteracted(world, tilePos, null, direction.getSide(), 0.5, 0.5);
     }
 
-    public void onPoweredBlockChange(final @NotNull World world, final @NotNull TilePos tilePos, boolean isPowered) {
+    public void onPoweredBlockChange(final @NotNull World world, final @NotNull TilePosc tilePos, boolean isPowered) {
         final int data = world.getBlockData(tilePos);
 
         if ((data & MASK_HINGE) > 0) {
             isPowered = !isPowered;
         }
 
+        TilePos queryPos = new TilePos();
         if (this.isTop) {
-            final @Nullable Block<?> b = world.getBlock(tilePos.down());
+            final @Nullable Block<?> b = world.getBlock(tilePos.down(queryPos));
             if (b != null && b.getLogic() instanceof BlockLogicDoor) {
-                ((BlockLogicDoor) b.getLogic()).onPoweredBlockChange(world, tilePos.down(), isPowered);
+                ((BlockLogicDoor) b.getLogic()).onPoweredBlockChange(world, tilePos.down(queryPos), isPowered);
             }
             return;
         }
@@ -181,31 +184,32 @@ public class BlockLogicDoor
         if (isOpen == isPowered) {
             return;
         }
-        final @Nullable Block<?> b = world.getBlock(tilePos.up());
+        final @Nullable Block<?> b = world.getBlock(tilePos.up(queryPos));
         if (b != null && b.getLogic() instanceof BlockLogicDoor) {
-            world.setBlockDataNotify(tilePos.up(), data ^ MASK_OPENED);
+            world.setBlockDataNotify(tilePos.up(queryPos), data ^ MASK_OPENED);
         }
         world.setBlockDataNotify(tilePos, data ^ MASK_OPENED);
-        world.markBlocksDirty(tilePos.down(), tilePos);
+        world.markBlocksDirty(tilePos.down(queryPos), tilePos);
         world.playBlockEvent(tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         final int data = world.getBlockData(tilePos);
         final @Nullable Block<?> neighbor = Blocks.getBlock(id);
 
+        TilePos queryPos = new TilePos();
         if (this.isTop) {
-            final @Nullable Block<?> b = world.getBlock(tilePos.down());
+            final @Nullable Block<?> b = world.getBlock(tilePos.down(queryPos));
             if (!(b != null && b.getLogic() instanceof BlockLogicDoor)) {
                 world.setBlockIdNotify(tilePos, 0);
             }
             if (b != null && neighbor != null && neighbor.isSignalSource()) {
-                b.onNeighborChanged(world, tilePos.down(), id);
+                b.onNeighborChanged(world, tilePos.down(queryPos), id);
             }
         } else {
             boolean hasCommittedSuicide = false;
-            final @Nullable Block<?> otherBlock = world.getBlock(tilePos.up());
+            final @Nullable Block<?> otherBlock = world.getBlock(tilePos.up(queryPos));
             if (!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor)) {
                 world.setBlockIdNotify(tilePos, 0);
                 hasCommittedSuicide = true;
@@ -215,25 +219,26 @@ public class BlockLogicDoor
                 world.setBlockIdNotify(tilePos, 0);
                 hasCommittedSuicide = true;
                 if (otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor) {
-                    world.setBlockIdNotify(tilePos.up(), 0);
+                    world.setBlockIdNotify(tilePos.up(queryPos), 0);
                 }
             }
             if (!hasCommittedSuicide && neighbor != null && neighbor.isSignalSource()) {
-                final boolean hasSignal = world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(tilePos.up());
+                final boolean hasSignal = world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(tilePos.up(queryPos));
                 this.onPoweredBlockChange(world, tilePos, hasSignal);
             }
         }
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
+        TilePos queryPos = new TilePos();
         if (this.isTop) {
-            if (world.getBlockLogic(tilePos.down(), BlockLogicDoor.class) != null) {
-                world.setBlockIdNotify(tilePos.down(), 0);
+            if (world.getBlockLogic(tilePos.down(queryPos), BlockLogicDoor.class) != null) {
+                world.setBlockIdNotify(tilePos.down(queryPos), 0);
             }
         } else {
-            if (world.getBlockLogic(tilePos.up(), BlockLogicDoor.class) != null) {
-                world.setBlockIdNotify(tilePos.up(), 0);
+            if (world.getBlockLogic(tilePos.up(queryPos), BlockLogicDoor.class) != null) {
+                world.setBlockIdNotify(tilePos.up(queryPos), 0);
             }
         }
     }
@@ -242,9 +247,9 @@ public class BlockLogicDoor
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
         if (this.droppedItem == null) return null;
         if (this.requireTool && dropCause != EnumDropCause.IMPROPER_TOOL) {
-            return new ItemStack[] { new ItemStack(this.droppedItem.get()) };
+            return new ItemStack[]{new ItemStack(this.droppedItem.get())};
         } else if (!this.requireTool) {
-            return new ItemStack[] { new ItemStack(this.droppedItem.get()) };
+            return new ItemStack[]{new ItemStack(this.droppedItem.get())};
         }
 
         return null;
@@ -266,25 +271,26 @@ public class BlockLogicDoor
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
-        if (tilePos.y >= world.getHeightBlocks() - 1) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        if (tilePos.y() >= world.getHeightBlocks() - 1) {
             return false;
         } else {
-            return this.isSupported(world, tilePos, world.getBlockData(tilePos)) && super.canPlaceAt(world, tilePos.up());
+            return this.isSupported(world, tilePos, world.getBlockData(tilePos)) && super.canPlaceAt(world, tilePos.up(new TilePos()));
         }
     }
 
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
-        if (tilePos.y >= world.getHeightBlocks() - 1) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
+        if (tilePos.y() >= world.getHeightBlocks() - 1) {
             return false;
         } else {
-            return this.isSupported(world, tilePos, data) && super.canPlaceAt(world, tilePos.up());
+            return this.isSupported(world, tilePos, data) && super.canPlaceAt(world, tilePos.up(new TilePos()));
         }
     }
 
-    public boolean isSupported(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public boolean isSupported(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         if (this.isTop) return true;
-        final @NotNull ISupport sBelow = world.getSupport(tilePos.down(), Side.TOP);
+        TilePos queryPos = new TilePos();
+        final @NotNull ISupport sBelow = world.getSupport(tilePos.down(queryPos), Side.TOP);
         final boolean opened = (data & MASK_OPENED) != 0;
         final boolean hinge = (data & MASK_HINGE) != 0;
         final @NotNull Side side;
@@ -294,22 +300,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 1: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 2: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 3: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
 
@@ -318,22 +324,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 1: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 2: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 3: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                 }
@@ -343,22 +349,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 1: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 2: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 3: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
 
@@ -367,22 +373,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 1: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 2: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 3: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection()), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                 }
@@ -392,28 +398,29 @@ public class BlockLogicDoor
     }
 
     @Override
-    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
     @Override
     public boolean canBePainted() {
-        return this.material == Material.wood;
+        return this.material == Materials.WOOD;
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
+        TilePos queryPos = new TilePos();
         final int data = world.getBlockData(tilePos);
         if (this.isTop) {
             world.setBlockIdDataRaw(tilePos, Blocks.DOOR_PLANKS_PAINTED_TOP.id(), data);
             Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, tilePos, color);
-            world.setBlockIdDataRaw(tilePos.down(), Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), data);
-            Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, tilePos.down(), color);
+            world.setBlockIdDataRaw(tilePos.down(queryPos), Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), data);
+            Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, tilePos.down(queryPos), color);
         } else {
             world.setBlockIdDataRaw(tilePos, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), data);
             Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, tilePos, color);
-            world.setBlockIdDataRaw(tilePos.up(), Blocks.DOOR_PLANKS_PAINTED_TOP.id(), data);
-            Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, tilePos.up(), color);
+            world.setBlockIdDataRaw(tilePos.up(queryPos), Blocks.DOOR_PLANKS_PAINTED_TOP.id(), data);
+            Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, tilePos.up(queryPos), color);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
index 4b5aadc65..46654d5ca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -20,7 +21,7 @@ public class BlockLogicDoorPainted
 
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Items.DOOR_OAK_PAINTED, 1, 15 - (data >> 4 & 0xF)) };
+        return new ItemStack[]{new ItemStack(Items.DOOR_OAK_PAINTED, 1, 15 - (data >> 4 & 0xF))};
     }
 
     @Override
@@ -39,24 +40,24 @@ public class BlockLogicDoorPainted
     }
 
     @Override
-    public void removeDye(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP.id() : Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), data & 0xF);
         if (this.isTop) {
-            world.setBlockIdDataNotify(tilePos.down(), Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), data & 0xF);
+            world.setBlockIdDataNotify(tilePos.down(new TilePos()), Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), data & 0xF);
         } else {
-            world.setBlockIdDataNotify(tilePos.up(), Blocks.DOOR_PLANKS_OAK_TOP.id(), data & 0xF);
+            world.setBlockIdDataNotify(tilePos.up(new TilePos()), Blocks.DOOR_PLANKS_OAK_TOP.id(), data & 0xF);
         }
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int data = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, data & 0xF | this.toMetadata(color));
         if (this.isTop) {
-            world.setBlockDataNotify(tilePos.down(), data & 0xF | this.toMetadata(color));
+            world.setBlockDataNotify(tilePos.down(new TilePos()), data & 0xF | this.toMetadata(color));
         } else {
-            world.setBlockDataNotify(tilePos.up(), data & 0xF | this.toMetadata(color));
+            world.setBlockDataNotify(tilePos.up(new TilePos()), data & 0xF | this.toMetadata(color));
         }
     }
 }
